package tests;

import ProcessingUnit.ProcessingUnit.ProcessingUnitStructure;
import ProcessingUnit.ProcessingUnitServer.ProcessingUnitServerStructure;
import Sequencer.Sequencer.SequencerState;
import references.references.*;

import static Sequencer.Sequencer.Sequencer.SequencerInitialize;
import static Sequencer.Sequencer.Sequencer.SequencerIteration;
import static arrays.arrays.arrays.*;
import static references.references.references.*;
import static testing.testing.testing.AssertEquals;
import static testing.testing.testing.AssertStringEquals;

public class tests {
    public static double test(){
        NumberReference failures;

        failures = CreateNumberReference(0d);

        TestSequencerIteration1(failures);
        TestSequencerIteration2(failures);

        return failures.numberValue;
    }

    public static void TestSequencerIteration1(NumberReference failures) {
        ProcessingUnitServerStructure [] clients;
        ProcessingUnitServerStructure adminPort;
        ProcessingUnitStructure server;
        char [] str;
        SequencerState state;

        state = new SequencerState();

        adminPort = new ProcessingUnitServerStructure();
        adminPort.requests = new NumberArrayReference[1];
        adminPort.requests[0] = CreateNumberArrayReferenceLengthValue(0d, 0d);
        adminPort.requestCount = 0d;
        adminPort.responseCount = 0d;
        adminPort.responses = new NumberArrayReference[1];
        adminPort.responses[0] = new NumberArrayReference();
        adminPort.check = new double [2];
        adminPort.check[0] = 0d;
        adminPort.check[1] = 20d;

        clients = new ProcessingUnitServerStructure[2];
        clients[0] = new ProcessingUnitServerStructure();
        clients[0].requests = new NumberArrayReference[1];
        clients[0].requests[0] = new NumberArrayReference();
        clients[0].requests[0].numberArray = StringToNumberArray("request 1".toCharArray());
        clients[0].requestCount = 0d;
        clients[0].responseCount = 0d;
        clients[0].responses = new NumberArrayReference[1];
        clients[0].check = new double [1];
        clients[0].check[0] = 0d;

        clients[1] = new ProcessingUnitServerStructure();
        clients[1].requests = new NumberArrayReference[1];
        clients[1].requests[0] = new NumberArrayReference();
        clients[1].requests[0].numberArray = StringToNumberArray("request 2".toCharArray());
        clients[1].requestCount = 0d;
        clients[1].responseCount = 0d;
        clients[1].responses = new NumberArrayReference[1];
        clients[1].check = new double [1];
        clients[1].check[0] = 0d;

        server = new ProcessingUnitStructure();
        server.requests = new NumberArrayReference[2];
        server.requests[0] = new NumberArrayReference();
        server.requests[1] = new NumberArrayReference();
        server.requestCount = 0d;
        server.responseCount = 0d;
        server.responses = new NumberArrayReference[2];
        server.responses[0] = new NumberArrayReference();
        server.responses[0].numberArray = StringToNumberArray("response 1".toCharArray());
        server.responses[1] = new NumberArrayReference();
        server.responses[1].numberArray = StringToNumberArray("response 2".toCharArray());
        server.check = new double [1];
        server.check[0] = 0d;

        SequencerInitialize(clients, adminPort, server, state);

        SequencerIteration(clients, adminPort, server, state);

        AssertEquals(clients[0].responseCount, 1d, failures);
        AssertEquals(clients[1].responseCount, 1d, failures);

        AssertEquals(server.requestCount, 2d, failures);

        str = NumberArrayToString(server.requests[0].numberArray);
        AssertStringEquals(str, "request 1".toCharArray(), failures);

        str = NumberArrayToString(server.requests[1].numberArray);
        AssertStringEquals(str, "request 2".toCharArray(), failures);

        str = NumberArrayToString(clients[0].responses[0].numberArray);
        AssertStringEquals(str, "response 1".toCharArray(), failures);

        str = NumberArrayToString(clients[1].responses[0].numberArray);
        AssertStringEquals(str, "response 2".toCharArray(), failures);

        str = NumberArrayToString(adminPort.responses[0].numberArray);
        AssertStringEquals(str, "{\"idles\":0,\"Client Reqs\":[1,1]}".toCharArray(), failures);
    }

    public static void TestSequencerIteration2(NumberReference failures) {
        ProcessingUnitServerStructure [] clients;
        ProcessingUnitServerStructure adminPort;
        ProcessingUnitStructure server;
        char [] str;
        SequencerState state;

        state = new SequencerState();

        adminPort = new ProcessingUnitServerStructure();
        adminPort.requests = new NumberArrayReference[1];
        adminPort.requests[0] = CreateNumberArrayReferenceLengthValue(0d, 0d);
        adminPort.requestCount = 0d;
        adminPort.responseCount = 0d;
        adminPort.responses = new NumberArrayReference[1];
        adminPort.responses[0] = new NumberArrayReference();
        adminPort.check = new double [2];
        adminPort.check[0] = 1d;
        adminPort.check[1] = 20d;

        clients = new ProcessingUnitServerStructure[2];
        clients[0] = new ProcessingUnitServerStructure();
        clients[0].requests = new NumberArrayReference[1];
        clients[0].requests[0] = new NumberArrayReference();
        clients[0].requests[0].numberArray = StringToNumberArray("request 1".toCharArray());
        clients[0].requestCount = 0d;
        clients[0].responseCount = 0d;
        clients[0].responses = new NumberArrayReference[1];
        clients[0].check = new double [2];
        clients[0].check[0] = 1d;
        clients[0].check[1] = 0d;

        clients[1] = new ProcessingUnitServerStructure();
        clients[1].requests = new NumberArrayReference[1];
        clients[1].requests[0] = new NumberArrayReference();
        clients[1].requests[0].numberArray = StringToNumberArray("request 2".toCharArray());
        clients[1].requestCount = 0d;
        clients[1].responseCount = 0d;
        clients[1].responses = new NumberArrayReference[1];
        clients[1].check = new double [2];
        clients[1].check[0] = 0d;
        clients[1].check[1] = 1d;

        server = new ProcessingUnitStructure();
        server.requests = new NumberArrayReference[2];
        server.requests[0] = new NumberArrayReference();
        server.requests[1] = new NumberArrayReference();
        server.requestCount = 0d;
        server.responseCount = 0d;
        server.responses = new NumberArrayReference[2];
        server.responses[0] = new NumberArrayReference();
        server.responses[0].numberArray = StringToNumberArray("response 1".toCharArray());
        server.responses[1] = new NumberArrayReference();
        server.responses[1].numberArray = StringToNumberArray("response 2".toCharArray());
        server.check = new double [1];
        server.check[0] = 0d;

        SequencerInitialize(clients, adminPort, server, state);

        SequencerIteration(clients, adminPort, server, state);
        SequencerIteration(clients, adminPort, server, state);

        AssertEquals(clients[0].responseCount, 1d, failures);
        AssertEquals(clients[1].responseCount, 1d, failures);

        AssertEquals(server.requestCount, 2d, failures);

        str = NumberArrayToString(server.requests[0].numberArray);
        AssertStringEquals(str, "request 2".toCharArray(), failures);

        str = NumberArrayToString(server.requests[1].numberArray);
        AssertStringEquals(str, "request 1".toCharArray(), failures);

        str = NumberArrayToString(clients[0].responses[0].numberArray);
        AssertStringEquals(str, "response 2".toCharArray(), failures);

        str = NumberArrayToString(clients[1].responses[0].numberArray);
        AssertStringEquals(str, "response 1".toCharArray(), failures);

        str = NumberArrayToString(adminPort.responses[0].numberArray);
        AssertStringEquals(str, "{\"idles\":0,\"Client Reqs\":[1,1]}".toCharArray(), failures);
    }
}







